/************************************************************************************/
/*  Program name CAPGLEXT_JE_HEADERS.sql                                            */
/*  Creater:  NIP Karen (PCCW - UniHub)                                             */
/*************   History   *************************                                */
/* 9 JAN, 2005   NIP Karen         First created                                    */
/************************************************************************************/
SET VERIFY OFF
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPGLEXT_JE_HEADERS';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPGL_JE_HEADERS.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT 
		GJH.*
	FROM   
		GL_JE_HEADERS			GJH
    ,	GL_SETS_OF_BOOKS		SOB
	WHERE	GJH.SET_OF_BOOKS_ID	=	SOB.SET_OF_BOOKS_ID
	AND		SUBSTR(SOB.SHORT_NAME,5,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.JE_HEADER_ID||CHR(9)||
				C1.LAST_UPDATE_DATE||CHR(9)||
					C1.LAST_UPDATED_BY||CHR(9)||
					C1.SET_OF_BOOKS_ID||CHR(9)||
				C1.JE_CATEGORY||CHR(9)||
				C1.JE_SOURCE||CHR(9)||
				C1.PERIOD_NAME||CHR(9)||
				C1.NAME||CHR(9)||
				C1.CURRENCY_CODE||CHR(9)||
				C1.STATUS||CHR(9)||
				C1.DATE_CREATED||CHR(9)||
				C1.ACCRUAL_REV_FLAG||CHR(9)||
				C1.MULTI_BAL_SEG_FLAG||CHR(9)||
				C1.ACTUAL_FLAG||CHR(9)||
				C1.DEFAULT_EFFECTIVE_DATE||CHR(9)||
				C1.TAX_STATUS_CODE||CHR(9)||
				C1.CONVERSION_FLAG||CHR(9)||
				C1.CREATION_DATE||CHR(9)||
					C1.CREATED_BY||CHR(9)||
				C1.LAST_UPDATE_LOGIN||CHR(9)||
					C1.ENCUMBRANCE_TYPE_ID||CHR(9)||
				C1.BUDGET_VERSION_ID||CHR(9)||
				C1.BALANCED_JE_FLAG||CHR(9)||
				C1.BALANCING_SEGMENT_VALUE||CHR(9)||
				C1.JE_BATCH_ID||CHR(9)||
				C1.FROM_RECURRING_HEADER_ID||CHR(9)||
				C1.UNIQUE_DATE||CHR(9)||
				C1.EARLIEST_POSTABLE_DATE||CHR(9)||
				C1.POSTED_DATE||CHR(9)||
				C1.ACCRUAL_REV_EFFECTIVE_DATE||CHR(9)||
				C1.ACCRUAL_REV_PERIOD_NAME||CHR(9)||
				C1.ACCRUAL_REV_STATUS||CHR(9)||
				C1.ACCRUAL_REV_JE_HEADER_ID||CHR(9)||
				C1.ACCRUAL_REV_CHANGE_SIGN_FLAG||CHR(9)||
				C1.DESCRIPTION||CHR(9)||
				C1.CONTROL_TOTAL||CHR(9)||
				C1.RUNNING_TOTAL_DR||CHR(9)||
				C1.RUNNING_TOTAL_CR||CHR(9)||
				C1.RUNNING_TOTAL_ACCOUNTED_DR||CHR(9)||
				C1.RUNNING_TOTAL_ACCOUNTED_CR||CHR(9)||
				C1.CURRENCY_CONVERSION_RATE||CHR(9)||
				C1.CURRENCY_CONVERSION_TYPE||CHR(9)||
				C1.CURRENCY_CONVERSION_DATE||CHR(9)||
				C1.EXTERNAL_REFERENCE||CHR(9)||
				C1.PARENT_JE_HEADER_ID||CHR(9)||
				C1.REVERSED_JE_HEADER_ID||CHR(9)||
				C1.ORIGINATING_BAL_SEG_VALUE||CHR(9)||
				C1.INTERCOMPANY_MODE||CHR(9)||
				C1.DR_BAL_SEG_VALUE||CHR(9)||
				C1.CR_BAL_SEG_VALUE||CHR(9)||
				C1.ATTRIBUTE1||CHR(9)||
				C1.ATTRIBUTE2||CHR(9)||
				C1.ATTRIBUTE3||CHR(9)||
				C1.ATTRIBUTE4||CHR(9)||
				C1.ATTRIBUTE5||CHR(9)||
				C1.ATTRIBUTE6||CHR(9)||
				C1.ATTRIBUTE7||CHR(9)||
				C1.ATTRIBUTE8||CHR(9)||
				C1.ATTRIBUTE9||CHR(9)||
				C1.ATTRIBUTE10||CHR(9)||
				C1.CONTEXT||CHR(9)||
				C1.GLOBAL_ATTRIBUTE_CATEGORY||CHR(9)||
				C1.GLOBAL_ATTRIBUTE1||CHR(9)||
				C1.GLOBAL_ATTRIBUTE2||CHR(9)||
				C1.GLOBAL_ATTRIBUTE3||CHR(9)||
				C1.GLOBAL_ATTRIBUTE4||CHR(9)||
				C1.GLOBAL_ATTRIBUTE5||CHR(9)||
				C1.GLOBAL_ATTRIBUTE6||CHR(9)||
				C1.GLOBAL_ATTRIBUTE7||CHR(9)||
				C1.GLOBAL_ATTRIBUTE8||CHR(9)||
				C1.GLOBAL_ATTRIBUTE9||CHR(9)||
				C1.GLOBAL_ATTRIBUTE10||CHR(9)||
				C1.USSGL_TRANSACTION_CODE||CHR(9)||
				C1.CONTEXT2||CHR(9)||
					C1.DOC_SEQUENCE_ID||CHR(9)||
				C1.DOC_SEQUENCE_VALUE||CHR(9)||
				C1.JGZZ_RECON_CONTEXT||CHR(9)||
				C1.JGZZ_RECON_REF||CHR(9)||
				C1.REFERENCE_DATE||CHR(9)||
				C1.LOCAL_DOC_SEQUENCE_ID||CHR(9)||
				C1.LOCAL_DOC_SEQUENCE_VALUE||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetUser(C1.CREATED_BY)||CHR(9)||
				CAPBREXT_COMMON.GetSOBShortName(C1.SET_OF_BOOKS_ID)||CHR(9)||
				CAPBREXT_COMMON.GetEncumType(C1.ENCUMBRANCE_TYPE_ID)||CHR(9)||
				CAPBREXT_COMMON.GetDocSeqName(C1.DOC_SEQUENCE_ID)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/